High risk of breaking in future versions